#! /usr/bin/env python
# -*- coding: utf-8 -*-

import sys

file = "/etc/default/grub"
cmdentry= "GRUB_CMDLINE_LINUX_DEFAULT"
modfile = open(file)
lines = modfile.readlines()
modfile.close()

new_lines = []

argv = sys.argv
if len(argv) > 2:
    if argv[1] == "enable":
        opts = argv[2:]
        opts_check = opts
        new_opts= []
        for opt in opts:
            new_opts.append(opt.split("="))
        for line in lines:
            for opt in new_opts:
                try:
                    if line.split("=")[0] == opt[0] or line.split("=")[0] == "#"+opt[0]:
                        print "* Replacing %s with %s" %(line.replace("\n",""), "%s=%s" %(opt[0],opt[1]))
                        new_lines.append("%s=%s" %(opt[0],opt[1]))
                        opts_check.remove("%s=%s" %(opt[0],opt[1]))
                    else:
                        if new_lines[len(new_lines)-1] != line:
                            new_lines.append(line)
                except:
                    new_lines.append(line)
        for opt in opts_check:
            new_lines.append(opt)
    elif argv[1] == "disable":
        opts = argv[2:]
        for line in lines:
            for opt in opts:
                try:
                    if line.split("=")[0] == opt or line.split("=")[0] == "#"+opt:
                        print "* Disabling %s " %(line.replace("\n",""))
                        try:
                            new_lines.append("#%s=%s\n" %(opt, line.split("=")[1]))
                        except:
                            new_lines.append("#%s\n" %(opt))
                    else:
                        if new_lines[len(new_lines)-1] != line:
                            new_lines.append(line)
                except:
                    new_lines.append(line)
    elif argv[1] == "addcmd":
        opts_check = []
        new_cmd = []
        for line in lines:
            try:
                if line.split("=")[0] == cmdentry:
                    old_cmd = line[line.index("=")+1:].replace('"','').split()
                    print old_cmd
                    for l in old_cmd:
                        for opt in argv[2:]:
                            if ((opt.split("=")[0] == l) or (opt.split("=")[0] == l.split("=")[0])) and (l.replace("\n","")) != opt:
                                print "* Changing <%s> to <%s>" %(l.replace("\n",""), "%s" %(opt))
                                if l not in new_cmd:
                                    new_cmd.append(l)
                                opts_check.append(opt)
                            elif ((opt.split("=")[0] == l) or (opt.split("=")[0] == l.split("=")[0])) and (l.replace("\n","")) == opt:
                                print "* <%s> already set!" %(l.replace("\n",""))
                                if l not in new_cmd:
                                    new_cmd.append(l)
                                opts_check.append(opt)
                            else:
                                if l not in new_cmd:
                                    new_cmd.append(l)

                    for opt in argv[2:]:
                        if not opt in opts_check:
                            print "* Adding <%s>" %(opt)
                            new_cmd.append(opt)
                    new_str = ""
                    if   len(new_cmd) == 1:
                        new_str = new_cmd[0]
                    elif len(new_cmd) > 1:
                        new_str = new_cmd[0]
                        for cmd in new_cmd[1:]:
                            new_str = "%s %s" %(new_str,cmd)
                    new_lines.append('%s="%s"\n'%(cmdentry, new_str))
                else:
                    if new_lines[len(new_lines)-1] != line:
                        new_lines.append(line)
            except IndexError, e:
                print "ERROR by IndexError: %s" %(e)
                new_lines.append(line)
    elif argv[1] == "rmcmd":
        cmd_found = []
        new_cmd = []
        for line in lines:
            try:
                if line.split("=")[0] == cmdentry:
                    old_cmd = line[line.index("=")+1:].replace('"','').split()
                    for l in old_cmd:
                        for opt in argv[2:]:
                            if ((opt.split("=")[0] == l) or (opt.split("=")[0] == l.split("=")[0])) and (l.replace("\n","")) == opt:
                                print "* Removed : <%s>" %(l.replace("\n",""))
                                cmd_found.append()
                            else:
                                if l not in new_cmd:
                                    new_cmd.append(l)
                    
                    for c in argv[2:]:
                        if c not in cmd_found:
                            print "* <%s> not found!" %(c)

                    new_str = ""
                    if   len(new_cmd) == 1:
                        new_str = new_cmd[0]
                    elif len(new_cmd) > 1:
                        new_str = new_cmd[0]
                        for cmd in new_cmd[1:]:
                            new_str = "%s %s" %(new_str,cmd)
                    new_lines.append('%s="%s"\n'%(cmdentry, new_str))
                else:
                    if new_lines[len(new_lines)-1] != line:
                        new_lines.append(line)
            except IndexError, e:
                #print "ERROR by IndexError: %s" %(e)
                new_lines.append(line)
    
    


    try:
        grubfile = open(file, "w")
        grubfile.writelines(new_lines)
        grubfile.close()
    except IOError:
        content = ""
        for line in new_lines:
            content = content+line
        print "\n** Suggested %s: \n%s" %(file, content)
